diff mbox series

[[meta-swupdate] 6/7] rescuegui: a GUI for rescue system

Message ID 1531042617-6503-6-git-send-email-sbabic@denx.de
State Accepted
Headers show
Series [[meta-swupdate] 6/7] rescuegui: a GUI for rescue system | expand

Commit Message

Stefano Babic July 8, 2018, 9:36 a.m. UTC
rescueGUI is a small application drawing on the Linux Framebuffer
with a small footprint and suitable to be added to the rescue system.
It is written in LUA with a binding to SWUpdate's progress interface.

Signed-off-by: Stefano Babic <sbabic@denx.de>
---
 recipes-support/rescuegui/files/config.lua |   4 +
 recipes-support/rescuegui/files/rescuegui  | 176 +++++++++++++++++++++++++++++
 recipes-support/rescuegui/rescuegui_git.bb |  54 +++++++++
 3 files changed, 234 insertions(+)
 create mode 100644 recipes-support/rescuegui/files/config.lua
 create mode 100644 recipes-support/rescuegui/files/rescuegui
 create mode 100644 recipes-support/rescuegui/rescuegui_git.bb
diff mbox series

Patch

diff --git a/recipes-support/rescuegui/files/config.lua b/recipes-support/rescuegui/files/config.lua
new file mode 100644
index 0000000..cd45225
--- /dev/null
+++ b/recipes-support/rescuegui/files/config.lua
@@ -0,0 +1,4 @@ 
+APP_ID = "PDM-3 Recovery System"
+LOGO = "IFM/logo-ifm.png"
+NOREBOOT = true
+
diff --git a/recipes-support/rescuegui/files/rescuegui b/recipes-support/rescuegui/files/rescuegui
new file mode 100644
index 0000000..6caa6e5
--- /dev/null
+++ b/recipes-support/rescuegui/files/rescuegui
@@ -0,0 +1,176 @@ 
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides:          rescuegui
+# Required-Start:    $local_fs
+# Should-Start:
+# Required-Stop:     $local_fs
+# Should-Stop:
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Start rescuegui application
+### END INIT INFO
+
+# The definition of actions: (From LSB 3.1.0)
+# start         start the service
+# stop          stop the service
+# restart       stop and restart the service if the service is already running,
+#               otherwise start the service
+# try-restart	restart the service if the service is already running
+# reload	cause the configuration of the service to be reloaded without
+#               actually stopping and restarting the service
+# force-reload	cause the configuration to be reloaded if the service supports
+#               this, otherwise restart the service if it is running
+# status	print the current status of the service
+
+# The start, stop, restart, force-reload, and status actions shall be supported
+# by all init scripts; the reload and the try-restart actions are optional
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+
+DESC="rescuegui"
+NAME="SWUpdateGUI"
+DAEMON=/opt/rescueGUI/SWUpdateGUI.lua
+PIDFILE=/var/run/$NAME.pid
+
+. /etc/init.d/functions || exit 1
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+#
+# Function that starts the daemon/service
+#
+do_start() {
+	local status pid
+
+	status=0
+	pid=`pidofproc $NAME` || status=$?
+	case $status in
+	0)
+		echo "$DESC already running ($pid)."
+		exit 1
+		;;
+	*)
+		echo "Starting $DESC ..."
+		cd /opt/rescueGUI
+		export FONTDIR=/usr/share/fonts/truetype
+		exec $DAEMON &
+		exit 0
+		;;
+	esac
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop() {
+	local pid status
+
+	status=0
+	pid=`pidofproc $NAME` || status=$?
+	case $status in
+	0)
+		# Exit when fail to stop, the kill would complain when fail
+		kill -s 15 $pid >/dev/null && rm -f $PIDFILE && \
+			echo "Stopped $DESC ($pid)." || exit $?
+		;;
+	*)
+		echo "$DESC is not running; none killed." >&2
+		;;
+	esac
+
+	# Wait for children to finish too if this is a daemon that forks
+	# and if the daemon is only ever run from this initscript.
+	# If the above conditions are not satisfied then add some other code
+	# that waits for the process to drop all resources that could be
+	# needed by services started subsequently.  A last resort is to
+	# sleep for some time.
+	return $status
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+	local pid status
+
+	status=0
+        # If the daemon can reload its configuration without
+        # restarting (for example, when it is sent a SIGHUP),
+        # then implement that here.
+	pid=`pidofproc $NAME` || status=$?
+	case $status in
+	0)
+		echo "Reloading $DESC ..."
+		kill -s 1 $pid || exit $?
+		;;
+	*)
+		echo "$DESC is not running; none reloaded." >&2
+		;;
+	esac
+	exit $status
+}
+
+
+#
+# Function that shows the daemon/service status
+#
+status_of_proc () {
+	local pid status
+
+	status=0
+	# pidof output null when no program is running, so no "2>/dev/null".
+	pid=`pidofproc $NAME` || status=$?
+	case $status in
+	0)
+		echo "$DESC is running ($pid)."
+		exit 0
+		;;
+	*)
+		echo "$DESC is not running." >&2
+		exit $status
+		;;
+	esac
+}
+
+case "$1" in
+start)
+	do_start
+	;;
+stop)
+	do_stop || exit $?
+	;;
+status)
+	status_of_proc
+	;;
+restart)
+	# Always start the service regardless the status of do_stop
+	do_stop
+	do_start
+	;;
+try-restart|force-reload)
+	# force-reload is the same as reload or try-restart according
+	# to its definition, the reload is not implemented here, so
+	# force-reload is the alias of try-restart here, but it should
+	# be the alias of reload if reload is implemented.
+	#
+	# Only start the service when do_stop succeeds
+	do_stop && do_start
+	;;
+#reload)
+	# If the "reload" action is implemented properly, then let the
+	# force-reload be the alias of reload, and remove it from
+	# try-restart|force-reload)
+	#
+	#do_reload
+	#;;
+*)
+	echo "Usage: $0 {start|stop|status|restart|try-restart|force-reload}" >&2
+	exit 3
+	;;
+esac
+
diff --git a/recipes-support/rescuegui/rescuegui_git.bb b/recipes-support/rescuegui/rescuegui_git.bb
new file mode 100644
index 0000000..def2ee0
--- /dev/null
+++ b/recipes-support/rescuegui/rescuegui_git.bb
@@ -0,0 +1,54 @@ 
+SUMMARY="Simple GUI for SWUpdate in rescue mode"
+DESCRIPTION = "This is a simple GUI that allows to set network addresses \
+	and start an install from local media. It shows progress on the HMI"
+SECTION="swupdate"
+LICENSE = "GPLv2+"
+LIC_FILES_CHKSUM = "file://${COMMON_LICENSE_DIR}/GPL-2.0;md5=801f80980d171dd6425610833a22dbe6"
+
+inherit update-rc.d
+
+DEPENDS += "swupdate lua lua-swupdate luafilesystem"
+RDEPENDS_${PN} += "swupdate-tools"
+
+SRC_URI = "git://github.com/sbabic/SWUpdateGUI.git;protocol=https \
+     	   file://rescuegui \
+	   file://config.lua \
+	"
+
+# Modify these as desired
+PV = "1.0+git${SRCPV}"
+#SRCREV = "e286a994e7ed4fc660d644634abc4837c1f78beb"
+SRCREV = "${AUTOREV}"
+
+S = "${WORKDIR}/git"
+
+FILES_${PN} = "/opt ${sysconfdir}"
+
+do_configure () {
+	# Specify any needed configure commands here
+	:
+}
+
+do_compile () {
+	# Specify compilation commands here
+	:
+}
+
+do_install () {
+	install -d ${D}/opt/rescueGUI
+	install -d ${D}/opt/rescueGUI/tek/ui/locale/SWUpdate/SWUpdate-GUI
+	for f in ${S}/*.lua;do
+		install -m 755 ${f} ${D}/opt/rescueGUI
+	done
+	for f in ${S}/tek/ui/locale/SWUpdate/SWUpdate-GUI/*;do
+		install -m 644 ${f} ${D}/opt/rescueGUI/tek/ui/locale/SWUpdate/SWUpdate-GUI
+	done
+	
+	install -m 644 ${S}/config.lua ${D}/opt/rescueGUI
+	install -d ${D}/${sysconfdir}/init.d
+	install -m 755 ${WORKDIR}/rescuegui ${D}${sysconfdir}/init.d
+}
+
+# Be sure to run the GUI after starting SWUpdate
+INITSCRIPT_NAME = "rescuegui"
+INITSCRIPT_PARAMS = "defaults 90"